## ros-humble-irobot-create-nodes 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(irobot_create_nodes)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(angles REQUIRED)
find_package(control_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(irobot_create_msgs REQUIRED)
find_package(irobot_create_toolbox REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(tf2_ros REQUIRED)
find_package(Boost REQUIRED)

#### Libraries

set(dependencies
  angles
  control_msgs
  geometry_msgs
  sensor_msgs
  nav_msgs
  irobot_create_msgs
  irobot_create_toolbox
  nav_msgs
  rclcpp
  rclcpp_action
  rclcpp_components
  tf2
  tf2_geometry_msgs
  tf2_ros
  Boost
)

# Hazards vector publisher
add_library(hazard_publisher_lib SHARED)
target_sources(
  hazard_publisher_lib
  PRIVATE
    src/hazards_vector_publisher.cpp
)
target_include_directories(hazard_publisher_lib PUBLIC include)
ament_target_dependencies(hazard_publisher_lib
  ${dependencies}
)

rclcpp_components_register_node(hazard_publisher_lib
  PLUGIN "irobot_create_nodes::HazardsVectorPublisher"
  EXECUTABLE hazards_vector_publisher)

# IR intensity vector publisher
add_library(ir_intensity_publisher_lib SHARED)
target_sources(
  ir_intensity_publisher_lib
  PRIVATE
    src/ir_intensity_vector_publisher.cpp
)
target_include_directories(ir_intensity_publisher_lib PUBLIC include)
ament_target_dependencies(ir_intensity_publisher_lib
  ${dependencies}
)

rclcpp_components_register_node(ir_intensity_publisher_lib
  PLUGIN "irobot_create_nodes::IrIntensityVectorPublisher"
  EXECUTABLE ir_intensity_vector_publisher)

# Motion control node
add_library(motion_control_lib SHARED)
target_sources(
  motion_control_lib
  PRIVATE
    src/motion_control_node.cpp
    src/motion_control/docking_behavior.cpp
    src/motion_control/drive_goal_behaviors.cpp
    src/motion_control/reflex_behavior.cpp
    src/motion_control/wall_follow_behavior.cpp
    src/motion_control/wall_follow_states.cpp
)
target_include_directories(motion_control_lib PUBLIC include)
ament_target_dependencies(motion_control_lib
  ${dependencies}
)

rclcpp_components_register_node(motion_control_lib
  PLUGIN "irobot_create_nodes::MotionControlNode"
  EXECUTABLE motion_control)

# Wheel status publisher
add_library(wheel_status_publisher_lib SHARED)
target_sources(
  wheel_status_publisher_lib
  PRIVATE
    src/wheels_publisher.cpp
)
target_include_directories(wheel_status_publisher_lib PUBLIC include)
ament_target_dependencies(wheel_status_publisher_lib
  ${dependencies}
)

rclcpp_components_register_node(wheel_status_publisher_lib
  PLUGIN "irobot_create_nodes::WheelsPublisher"
  EXECUTABLE wheel_status_publisher)

# Robot status publisher
add_library(robot_state_lib SHARED)
target_sources(
  robot_state_lib
  PRIVATE
    src/robot_state.cpp
)
target_include_directories(robot_state_lib PUBLIC include)
ament_target_dependencies(robot_state_lib
  ${dependencies}
)

rclcpp_components_register_node(robot_state_lib
  PLUGIN "irobot_create_nodes::RobotState"
  EXECUTABLE robot_state)

# UI Mgr Node
add_library(ui_mgr_lib SHARED)
target_sources(
  ui_mgr_lib
  PRIVATE
    src/ui_mgr.cpp
)
target_include_directories(ui_mgr_lib PUBLIC include)
ament_target_dependencies(ui_mgr_lib
  ${dependencies}
)

rclcpp_components_register_node(ui_mgr_lib
  PLUGIN "irobot_create_nodes::UIMgr"
  EXECUTABLE ui_mgr)

# Mock publisher
add_library(mock_publisher_lib SHARED)
target_sources(
  mock_publisher_lib
  PRIVATE
    src/mock_publisher.cpp
)
target_include_directories(mock_publisher_lib PUBLIC include)
ament_target_dependencies(mock_publisher_lib
  ${dependencies}
)

rclcpp_components_register_node(mock_publisher_lib
  PLUGIN "irobot_create_nodes::MockPublisher"
  EXECUTABLE mock_publisher)

# Kidnap estimator publisher
add_library(kidnap_estimator_publisher_lib SHARED)
target_sources(
  kidnap_estimator_publisher_lib
  PRIVATE
    src/kidnap_estimator_publisher.cpp
)
target_include_directories(kidnap_estimator_publisher_lib PUBLIC include)
ament_target_dependencies(kidnap_estimator_publisher_lib
  ${dependencies}
)

rclcpp_components_register_node(kidnap_estimator_publisher_lib
  PLUGIN "irobot_create_nodes::KidnapEstimator"
  EXECUTABLE kidnap_estimator_publisher)

set(libraries_names
  hazard_publisher_lib
  ir_intensity_publisher_lib
  motion_control_lib
  wheel_status_publisher_lib
  robot_state_lib
  ui_mgr_lib
  mock_publisher_lib
  kidnap_estimator_publisher_lib
)

#### Install

install(TARGETS ${libraries_names}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)
ament_export_libraries(${libraries_names})
ament_export_dependencies(${dependencies})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

=== debian/changelog ===
ros-humble-irobot-create-nodes (2.1.0-1jammy) jammy; urgency=high

  * Multi robot support (#207 <https://github.com/iRobotEducation/create3_sim/issues/207>)
  * Contributors: Roni Kreinin

 -- Ekumen <ekumen@irbt.onmicrosoft.com>  Mon, 15 May 2023 07:00:00 -0000

ros-humble-irobot-create-nodes (2.0.0-1jammy) jammy; urgency=high

  * Update to ROS 2 Humble (#197 <https://github.com/iRobotEducation/create3_sim/issues/197>)
    * Update message names to https://github.com/iRobotEducation/irobot_create_msgs/pull/10
    * rename dock topic into dock_status
    * comment ign_ros2_control dependency as it must be built from sources
    Co-authored-by: Francisco Martín Rico <mailto:fmrico@gmail.com>
  * add missing dependency to irobot-create-common-bringup (#186 <https://github.com/iRobotEducation/create3_sim/issues/186>)
  * Contributors: Alberto Soragna, Francisco Martín Rico

 -- Ekumen <ekumen@irbt.onmicrosoft.com>  Thu, 19 Jan 2023 08:00:00 -0000

ros-humble-irobot-create-nodes (1.0.1-1jammy) jammy; urgency=high

  * add boost as explicit dependency and remove unnneded boost usage (#175 <https://github.com/iRobotEducation/create3_sim/issues/175>)
    * add boost as explicit dependency and remove unnneded boost usage
    * do not search for boost component in Boost library

 -- Ekumen <ekumen@irbt.onmicrosoft.com>  Tue, 12 Apr 2022 07:00:00 -0000

ros-humble-irobot-create-nodes (1.0.0-1jammy) jammy; urgency=high

  * Add audio action and move UI elements to ui_mgr node (#172 <https://github.com/iRobotEducation/create3_sim/issues/172>)
    * Add audio notes sequence action and move UI elements from mock to UI mgr node
    * fix linter error
    * add missing yaml file
    * fix flake8 error
  * Removed reliable QoS from subscriptions (#164 <https://github.com/iRobotEducation/create3_sim/issues/164>)
  * Update dependencies for build from source, throttle action feedback, add stub for audio command (#161 <https://github.com/iRobotEducation/create3_sim/issues/161>)
    * Update dependencies for build from source
    * Add stub for cmd_audio and throttle action feedback
    * fix packages from PR feedback
  * Reliable QoS for publishers (#158 <https://github.com/iRobotEducation/create3_sim/issues/158>)
    * reliable QoS for publishers
    * reliable QoS for publishers
    * Fixing tests
  * Split irobot_create_toolbox (#153 <https://github.com/iRobotEducation/create3_sim/issues/153>)
    * rename irobot_create_toolbox into irobot_create_nodes
    * move common utilities to irobot_create_toolbox
    * register irobot_create_nodes as rclcpp_components
    * update readme
    * use new node names in parameter files
    * remove declare parameter utility and fix linter tests
  * Contributors: Alberto Soragna, Justin Kearns, Santti4go, roni-kreinin

 -- Ekumen <ekumen@irbt.onmicrosoft.com>  Thu, 31 Mar 2022 07:00:00 -0000

=== debian/control ===
Source: ros-humble-irobot-create-nodes
Section: misc
Priority: optional
Maintainer: Ekumen <ekumen@irbt.onmicrosoft.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-cppcheck <!nocheck>, ros-humble-ament-cmake-cpplint <!nocheck>, ros-humble-ament-cmake-flake8 <!nocheck>, ros-humble-ament-cmake-lint-cmake <!nocheck>, ros-humble-ament-cmake-pep257 <!nocheck>, ros-humble-ament-cmake-uncrustify <!nocheck>, ros-humble-ament-cmake-xmllint <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-angles, ros-humble-control-msgs, ros-humble-geometry-msgs, ros-humble-irobot-create-msgs, ros-humble-irobot-create-toolbox, ros-humble-nav-msgs, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-tf2, ros-humble-tf2-geometry-msgs, ros-humble-tf2-ros, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-irobot-create-nodes
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-humble-angles, ros-humble-control-msgs, ros-humble-geometry-msgs, ros-humble-irobot-create-msgs, ros-humble-irobot-create-toolbox, ros-humble-nav-msgs, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-tf2, ros-humble-tf2-geometry-msgs, ros-humble-tf2-ros, ros-humble-ros-workspace
Description: ROS 2 Nodes for the simulated iRobot(R) Create(R) 3 Educational Robot.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-irobot-create-nodes//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
